package devguide.client;
import java.sql.Timestamp;
import oracle.jbo.ApplicationModule;
import oracle.jbo.Row;
import oracle.jbo.ViewObject;
import oracle.jbo.client.Configuration;
import oracle.jbo.domain.DBSequence;
import oracle.jbo.domain.Date;
public class TestCreatingServiceRequest {
  public static void main(String[] args) throws Throwable {
    String amDef = "devguide.model.SRService";
    String config = "SRServiceLocal";
    ApplicationModule am = Configuration.createRootApplicationModule(amDef, config);
    ViewObject svcReqs = am.findViewObject("ServiceRequests");
    Row newSvcReq = svcReqs.createRow();
    svcReqs.insertRow(newSvcReq);
    System.out.println("Status defaults to: "+newSvcReq.getAttribute("Status"));
    newSvcReq.setAttribute("CreatedBy",308); // Nancy Greenberg (user) 
    Date now = new Date(new Timestamp(System.currentTimeMillis()));
    newSvcReq.setAttribute("RequestDate",now);
    newSvcReq.setAttribute("ProdId",119); // Ice Maker
    newSvcReq.setAttribute("ProblemDescription","Cubes melt immediately");
    am.getTransaction().commit();
    DBSequence id = (DBSequence)newSvcReq.getAttribute("SvrId");
    System.out.println("Thanks, reference number is "+id.getSequenceNumber());
    Configuration.releaseRootApplicationModule(am, true);
  }
}
