package devguide.client;
import oracle.jbo.ApplicationModule;
import oracle.jbo.JboException;
import oracle.jbo.Key;
import oracle.jbo.Row;
import oracle.jbo.ViewObject;
import oracle.jbo.client.Configuration;
public class TestFindAndUpdate {
  public static void main(String[] args) {
    String        amDef = "devguide.model.SRService";
    String        config = "SRServiceLocal";
    ApplicationModule am = Configuration.createRootApplicationModule(amDef,config);
    ViewObject vo = am.findViewObject("ServiceRequests");
    Key svcReqKey = new Key(new Object[]{101});
    Row[] reqsFound = vo.findByKey(svcReqKey,1);
    if (reqsFound != null && reqsFound.length > 0) {
      Row svcReq = reqsFound[0];
      String curStatus = (String)svcReq.getAttribute("Status");
      System.out.println("Current status is: "+curStatus);
      try {
        svcReq.setAttribute("Status","Reopened");
      }
      catch (JboException ex) {
        System.out.println("ERROR: "+ex.getMessage());
      }
      svcReq.setAttribute("Status","Open");
      System.out.println("Current status is: "+svcReq.getAttribute("Status"));
      System.out.println("Assigned: "+svcReq.getAttribute("TechnicianEmail"));
      svcReq.setAttribute("AssignedTo",303); // Alexander Hunold (technician)
      System.out.println("Assigned: "+svcReq.getAttribute("TechnicianEmail"));
      am.getTransaction().rollback(); 
      System.out.println("Transaction cancelled");
    }
    Configuration.releaseRootApplicationModule(am,true);
  }  
}