package devguide.model.queries;
import devguide.model.entities.ProductImpl;
import devguide.model.entities.ServiceRequestImpl;
import devguide.model.entities.UserImpl;
import devguide.model.queries.common.ServiceRequestsRow;

import oracle.jbo.RowIterator;
import oracle.jbo.domain.DBSequence;
import oracle.jbo.domain.Date;
import oracle.jbo.domain.Number;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.server.ViewRowImpl;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
public class ServiceRequestsRowImpl extends ViewRowImpl implements ServiceRequestsRow {
  public static final int SVRID = 0;
  public static final int STATUS = 1;
  public static final int REQUESTDATE = 2;
  public static final int PROBLEMDESCRIPTION = 3;
  public static final int PRODID = 4;
  public static final int CREATEDBY = 5;
  public static final int ASSIGNEDTO = 6;
  public static final int ASSIGNEDDATE = 7;
  public static final int PRODUCTNAME = 8;
  public static final int PKPRODID = 9;
  public static final int TECHNICIANEMAIL = 10;
  public static final int PKTECHNICIANUSERID = 11;
  public static final int CUSTOMEREMAIL = 12;
  public static final int PKCUSTOMERUSERID = 13;
  public static final int SERVICEHISTORIES = 14;

  /**This is the default constructor (do not remove)
   */
  public ServiceRequestsRowImpl() {
  }

  /**Gets ServiceRequest entity object.
   */
  public ServiceRequestImpl getServiceRequest() {
    return (ServiceRequestImpl)getEntity(0);
  }

  /**Gets Product entity object.
   */
  public ProductImpl getProduct() {
    return (ProductImpl)getEntity(1);
  }

  /**Gets Technician entity object.
   */
  public UserImpl getTechnician() {
    return (UserImpl)getEntity(2);
  }

  /**Gets Customer entity object.
   */
  public UserImpl getCustomer() {
    return (UserImpl)getEntity(3);
  }

  /**Gets the attribute value for SVR_ID using the alias name SvrId
   */
  public DBSequence getSvrId() {
    return (DBSequence)getAttributeInternal(SVRID);
  }

  /**Gets the attribute value for STATUS using the alias name Status
   */
  public String getStatus() {
    return (String) getAttributeInternal(STATUS);
  }

  /**Sets <code>value</code> as attribute value for STATUS using the alias name Status
   */
  public void setStatus(String value) {
    setAttributeInternal(STATUS, value);
  }

  /**Gets the attribute value for REQUEST_DATE using the alias name RequestDate
   */
  public Date getRequestDate() {
    return (Date) getAttributeInternal(REQUESTDATE);
  }

  /**Sets <code>value</code> as attribute value for REQUEST_DATE using the alias name RequestDate
   */
  public void setRequestDate(Date value) {
    setAttributeInternal(REQUESTDATE, value);
  }

  /**Gets the attribute value for PROBLEM_DESCRIPTION using the alias name ProblemDescription
   */
  public String getProblemDescription() {
    return (String) getAttributeInternal(PROBLEMDESCRIPTION);
  }

  /**Sets <code>value</code> as attribute value for PROBLEM_DESCRIPTION using the alias name ProblemDescription
   */
  public void setProblemDescription(String value) {
    setAttributeInternal(PROBLEMDESCRIPTION, value);
  }

  /**Gets the attribute value for PROD_ID using the alias name ProdId
   */
  public Number getProdId() {
    return (Number) getAttributeInternal(PRODID);
  }

  /**Sets <code>value</code> as attribute value for PROD_ID using the alias name ProdId
   */
  public void setProdId(Number value) {
    setAttributeInternal(PRODID, value);
  }

  /**Gets the attribute value for CREATED_BY using the alias name CreatedBy
   */
  public Number getCreatedBy() {
    return (Number) getAttributeInternal(CREATEDBY);
  }

  /**Sets <code>value</code> as attribute value for CREATED_BY using the alias name CreatedBy
   */
  public void setCreatedBy(Number value) {
    setAttributeInternal(CREATEDBY, value);
  }

  /**Gets the attribute value for ASSIGNED_TO using the alias name AssignedTo
   */
  public Number getAssignedTo() {
    return (Number) getAttributeInternal(ASSIGNEDTO);
  }

  /**Sets <code>value</code> as attribute value for ASSIGNED_TO using the alias name AssignedTo
   */
  public void setAssignedTo(Number value) {
    setAttributeInternal(ASSIGNEDTO, value);
  }

  /**Gets the attribute value for ASSIGNED_DATE using the alias name AssignedDate
   */
  public Date getAssignedDate() {
    return (Date) getAttributeInternal(ASSIGNEDDATE);
  }

  /**Sets <code>value</code> as attribute value for ASSIGNED_DATE using the alias name AssignedDate
   */
  public void setAssignedDate(Date value) {
    setAttributeInternal(ASSIGNEDDATE, value);
  }

  /**Gets the attribute value for NAME using the alias name ProductName
   */
  public String getProductName() {
    return (String) getAttributeInternal(PRODUCTNAME);
  }

  /**Gets the attribute value for PROD_ID using the alias name PKProdId
   */
  public DBSequence getPKProdId() {
    return (DBSequence)getAttributeInternal(PKPRODID);
  }

  /**Gets the attribute value for EMAIL using the alias name TechnicianEmail
   */
  public String getTechnicianEmail() {
    return (String) getAttributeInternal(TECHNICIANEMAIL);
  }

  /**Gets the attribute value for USER_ID using the alias name PKTechnicianUserId
   */
  public Number getPKTechnicianUserId() {
    return (Number) getAttributeInternal(PKTECHNICIANUSERID);
  }

  /**Gets the attribute value for EMAIL using the alias name CustomerEmail
   */
  public String getCustomerEmail() {
    return (String) getAttributeInternal(CUSTOMEREMAIL);
  }

  /**Gets the attribute value for USER_ID using the alias name PKCustomerUserId
   */
  public Number getPKCustomerUserId() {
    return (Number) getAttributeInternal(PKCUSTOMERUSERID);
  }

  /**Gets the associated <code>RowIterator</code> using master-detail link ServiceHistories
   */
  public RowIterator getServiceHistories() {
    return (RowIterator)getAttributeInternal(SERVICEHISTORIES);
  }

  /**getAttrInvokeAccessor: generated method. Do not modify.
   */
  protected Object getAttrInvokeAccessor(int index, 
                                         AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case SVRID:
      return getSvrId();
    case STATUS:
      return getStatus();
    case REQUESTDATE:
      return getRequestDate();
    case PROBLEMDESCRIPTION:
      return getProblemDescription();
    case PRODID:
      return getProdId();
    case CREATEDBY:
      return getCreatedBy();
    case ASSIGNEDTO:
      return getAssignedTo();
    case ASSIGNEDDATE:
      return getAssignedDate();
    case PRODUCTNAME:
      return getProductName();
    case PKPRODID:
      return getPKProdId();
    case TECHNICIANEMAIL:
      return getTechnicianEmail();
    case PKTECHNICIANUSERID:
      return getPKTechnicianUserId();
    case CUSTOMEREMAIL:
      return getCustomerEmail();
    case PKCUSTOMERUSERID:
      return getPKCustomerUserId();
    case SERVICEHISTORIES:
      return getServiceHistories();
    default:
      return super.getAttrInvokeAccessor(index, attrDef);
    }
  }

  /**setAttrInvokeAccessor: generated method. Do not modify.
   */
  protected void setAttrInvokeAccessor(int index, Object value, 
                                       AttributeDefImpl attrDef) throws Exception {
    switch (index) {
    case STATUS:
      setStatus((String)value);
      return;
    case REQUESTDATE:
      setRequestDate((Date)value);
      return;
    case PROBLEMDESCRIPTION:
      setProblemDescription((String)value);
      return;
    case PRODID:
      setProdId((Number)value);
      return;
    case CREATEDBY:
      setCreatedBy((Number)value);
      return;
    case ASSIGNEDTO:
      setAssignedTo((Number)value);
      return;
    case ASSIGNEDDATE:
      setAssignedDate((Date)value);
      return;
    default:
      super.setAttrInvokeAccessor(index, value, attrDef);
      return;
    }
  }
}
