package devguide.model;
import oracle.jbo.Key;
import oracle.jbo.server.ApplicationModuleImpl;
import oracle.jbo.server.EntityDefImpl;
import oracle.jbo.server.EntityImpl;
import oracle.jbo.client.Configuration;
import oracle.jbo.*;
import oracle.jbo.domain.Number;
import oracle.jbo.domain.*;
import oracle.jbo.server.ViewLinkImpl;
import oracle.jbo.server.ViewObjectImpl;
// ---------------------------------------------------------------------
// ---    File generated by Oracle ADF Business Components Design Time.
// ---    Custom code may be added to this class.
// ---    Warning: Do not modify method signatures of generated methods.
// ---------------------------------------------------------------------
 /**
  * This custom application module class illustrates the same
  * example methods as SRServiceImpl2.java, except that here
  * we're using the generic EntityImpl class for working with
  * ServiceRequest, User, and Product entity objects instead of
  * using the strongly-typed custom entity object classes.
  */

public class SRServiceImpl extends ApplicationModuleImpl {
  /**This is the default constructor (do not remove)
   */
  public SRServiceImpl() {
  }
  /*
   * Helper method to return a ServiceRequest by Id
   */  
  private EntityImpl retrieveServiceRequestById(long requestId) {
    String entityName = "devguide.model.entities.ServiceRequest";
    EntityDefImpl svcReqDef = EntityDefImpl.findDefObject(entityName);
    Key svcReqKey = new Key(new Object[]{requestId});
    return svcReqDef.findByPrimaryKey(getDBTransaction(),svcReqKey);
  }
  /*
   * Find a ServiceRequest by Id
   */
  public String findServiceRequestStatus(long requestId) {
    EntityImpl svcReq = retrieveServiceRequestById(requestId);
    if (svcReq != null) {
      return (String)svcReq.getAttribute("Status");
    }
    return null;
  }
  
  // Original implementation of finding an entity by primary key
  // before we refactored the lookup functionality into the
  // retrieveServiceRequestById() helper method above.
  //
  //  public String findServiceRequestStatus(long requestId) {
  //    String entityName = "devguide.model.entities.ServiceRequest";
  //    EntityDefImpl svcReqDef = EntityDefImpl.findDefObject(entityName);
  //    Key svcReqKey = new Key(new Object[]{requestId});
  //    EntityImpl svcReq = svcReqDef.findByPrimaryKey(getDBTransaction(),svcReqKey);
  //    if (svcReq != null) {
  //      return (String)svcReq.getAttribute("Status");
  //    }
  //    else {
  //      return null;
  //    }
  //  }  

  /*
   * Create a new Product and Return its new id
   */  
  public long createProduct(String name, String description) {
    String entityName = "devguide.model.entities.Product";
    EntityDefImpl productDef = EntityDefImpl.findDefObject(entityName);
    EntityImpl newProduct = productDef.createInstance2(getDBTransaction(),null);
    newProduct.setAttribute("Name",name);
    newProduct.setAttribute("Description",description);
    try {
      getDBTransaction().commit(); 
    }
    catch (JboException ex) {
      getDBTransaction().rollback();
      throw ex;
    }
    DBSequence newIdAssigned = (DBSequence)newProduct.getAttribute("ProdId");
    return newIdAssigned.getSequenceNumber().longValue();
  }
  /*
   * Update the status of an existing service request
   */   
  public void updateRequestStatus(long requestId, String newStatus) {
    EntityImpl svcReq = retrieveServiceRequestById(requestId);
    if (svcReq != null) {
      svcReq.setAttribute("Status",newStatus);
      try {
        getDBTransaction().commit();
      }
      catch (JboException ex) {
        getDBTransaction().rollback();
        throw ex;
      }
    }
  }
  /*
   * Access an associated Used entity from the ServiceRequest entity
   */  
  public String findServiceRequestTechnician(long requestId) {
    EntityImpl svcReq = retrieveServiceRequestById(requestId);
    if (svcReq != null) {
      EntityImpl tech  = (EntityImpl)svcReq.getAttribute("TechnicianAssigned");
      if (tech != null) {
        return tech.getAttribute("FirstName")+" "+tech.getAttribute("LastName");
      }
      else {
        return "Unassigned";
      }
    }
    else {
      return null;
    }
  }  

 //Original main() method generated by the application module editor
  /**Sample main for debugging Business Components code using the tester.
   */
  public static void main(String[] args) {
    launchTester("devguide.model", /* package name */
      "SRServiceLocal" /* Configuration Name */);
  }
//  /*
//   * Testing method
//   */
//   public static void main(String[] args) {
//     String        amDef = "devguide.model.SRService";
//     String        config = "SRServiceLocal";
//     ApplicationModule am = Configuration.createRootApplicationModule(amDef,config);
//     /* 
//      * NOTE: This cast to use the SRServiceImpl class is OK since this
//      * ----  code is inside a business tier *Impl.java file and not in a
//      *       client class that is accessing the business tier from "outside".
//      */
//     SRServiceImpl service = (SRServiceImpl)am;
//     String status = service.findServiceRequestStatus(101);
//     System.out.println("Status of SR# 101 = " + status);
//     String techName = service.findServiceRequestTechnician(101);
//     System.out.println("Technician for SR# 101 = " + techName);
//     try {
//       service.updateRequestStatus(101,"Reopened");
//     }
//     catch (JboException ex) {
//       System.out.println("ERROR: "+ex.getMessage());
//     }
//     long id = 0;
//     try {
//       id = service.createProduct(null,"Makes Blended Fruit Drinks");
//     }
//     catch (JboException ex) {
//       System.out.println("ERROR: "+ex.getMessage());
//     }
//     id = service.createProduct("Smoothie Maker","Makes Blended Fruit Drinks");
//     System.out.println("New product created successfully with id = "+id);
//     Configuration.releaseRootApplicationModule(am,true);
//   }

  /**Container's getter for StaffList
   */
  public ViewObjectImpl getStaffList() {
    return (ViewObjectImpl)findViewObject("StaffList");
  }

  /**Container's getter for ServiceRequests
   */
  public ViewObjectImpl getServiceRequests() {
    return (ViewObjectImpl)findViewObject("ServiceRequests");
  }

  /**Container's getter for AssignedServiceRequests
   */
  public ViewObjectImpl getAssignedServiceRequests() {
    return (ViewObjectImpl)findViewObject("AssignedServiceRequests");
  }

  /**Container's getter for AssignedServiceHistories
   */
  public ViewObjectImpl getAssignedServiceHistories() {
    return (ViewObjectImpl)findViewObject("AssignedServiceHistories");
  }

  /**Container's getter for ServiceHistories
   */
  public ViewObjectImpl getServiceHistories() {
    return (ViewObjectImpl)findViewObject("ServiceHistories");
  }

  /**Container's getter for RequestsAssignedToTechnician1
   */
  public ViewLinkImpl getRequestsAssignedToTechnician1() {
    return (ViewLinkImpl)findViewLink("RequestsAssignedToTechnician1");
  }

  /**Container's getter for HistoryLinesForRequest1
   */
  public ViewLinkImpl getHistoryLinesForRequest1() {
    return (ViewLinkImpl)findViewLink("HistoryLinesForRequest1");
  }

  /**Container's getter for HistoryLinesForRequest2
   */
  public ViewLinkImpl getHistoryLinesForRequest2() {
    return (ViewLinkImpl)findViewLink("HistoryLinesForRequest2");
  }

  /**Container's getter for OpenProblemsAndAssignees
   */
  public ViewObjectImpl getOpenProblemsAndAssignees() {
    return (ViewObjectImpl)findViewObject("OpenProblemsAndAssignees");
  }
}
