package devguide.examples.client;
import oracle.jbo.ApplicationModule;
import oracle.jbo.Row;
import oracle.jbo.RowSet;
import oracle.jbo.ViewObject;
import oracle.jbo.client.Configuration;
public class TestClient2 {
  public static void main(String[] args) {
    String amDef = "devguide.examples.UserService";
    String config = "UserServiceLocal";
    ApplicationModule am = Configuration.createRootApplicationModule(amDef, config);
    ViewObject vo = am.findViewObject("UserList");
    // Add an extra where clause with a new named bind variable
    vo.setWhereClause("user_role = :TheUserRole");
    vo.defineNamedWhereClauseParam("TheUserRole", null, null);
    vo.setNamedWhereClauseParam("TheUserRole", "technician");
    // Show results when :TheUserRole = 'technician'
    executeAndShowResults(vo);
    Configuration.releaseRootApplicationModule(am, true);
  }
  private static void executeAndShowResults(ViewObject vo) {
    System.out.println("---");
    vo.executeQuery();
    while (vo.hasNext()) {
      Row curUser = vo.next();
      // Access the row set of details using the view link accessor attribute
      RowSet reqs = (RowSet)curUser.getAttribute("AssignedRequests");
      long numReqs = reqs.getEstimatedRowCount();
      System.out.println(curUser.getAttribute("UserId") + " " + 
                         curUser.getAttribute("Email")+" ["+
                         numReqs+" requests]");
      while (reqs.hasNext()) {
        Row curReq = reqs.next();
        System.out.println("--> (" + curReq.getAttribute("SvrId") + ") " + 
                           curReq.getAttribute("ProblemDescription"));
      }
    }
  }
}
