package devguide.examples.client;
import oracle.jbo.ApplicationModule;
import oracle.jbo.Row;
import oracle.jbo.ViewObject;
import oracle.jbo.client.Configuration;
import oracle.jbo.domain.Number;
public class TestClientBindVars {
  public static void main(String[] args) {
    String amDef = "devguide.examples.UserService";
    String config = "UserServiceLocal";
    ApplicationModule am = Configuration.createRootApplicationModule(amDef, config);
    ViewObject vo = am.findViewObject("UserList");
    // Set the two design time named bind variables
    vo.setNamedWhereClauseParam("TheName", "alex%");
    vo.setNamedWhereClauseParam("HighUserId", new Number(315));
    executeAndShowResults(vo);
    // Add an extra where clause with a new named bind variable
    vo.setWhereClause("user_id = :TheUserId");
    vo.defineNamedWhereClauseParam("TheUserId", null, null);
    vo.setNamedWhereClauseParam("TheUserId", new Number(303));
    executeAndShowResults(vo);
    vo.removeNamedWhereClauseParam("TheUserId");
    // Add an extra where clause with a new named bind variable
    vo.setWhereClause("user_role = :TheUserRole");
    vo.defineNamedWhereClauseParam("TheUserRole", null, null);
    vo.setNamedWhereClauseParam("TheUserRole", "user");
    // Show results when :TheUserRole = 'user'
    executeAndShowResults(vo);
    vo.setNamedWhereClauseParam("TheUserRole", "technician");
    // Show results when :TheUserRole = 'technician'
    executeAndShowResults(vo);
    Configuration.releaseRootApplicationModule(am, true);
  }
  private static void executeAndShowResults(ViewObject vo) {
    System.out.println("---");
    vo.executeQuery();
    while (vo.hasNext()) {
      Row curUser = vo.next();
      System.out.println(curUser.getAttribute("UserId") + " " + 
                         curUser.getAttribute("Email"));
    }
  }
}
