package devguide.examples.client;
import oracle.jbo.ApplicationModule;
import oracle.jbo.Row;
import oracle.jbo.ViewCriteria;
import oracle.jbo.ViewCriteriaRow;
import oracle.jbo.ViewObject;
import oracle.jbo.client.Configuration;
public class TestClientViewCriteria {
  public static void main(String[] args) {
    String amDef = "devguide.examples.UserService";
    String config = "UserServiceLocal";
    ApplicationModule am = Configuration.createRootApplicationModule(amDef, config);
    ViewObject vo = am.findViewObject("UserList");
    ViewCriteria vc = vo.createViewCriteria();
    ViewCriteriaRow vcr1 = vc.createViewCriteriaRow();
    ViewCriteriaRow vcr2 = vc.createViewCriteriaRow();
    vcr1.setAttribute("UserId","> 304");
    vcr1.setAttribute("Email","d%");
    vcr1.setAttribute("UserRole","technician");
    vcr2.setAttribute("UserId","IN (324,326)");
    vcr2.setAttribute("LastName","Baer");

    // Syntax to alter the second view critera row to use AND (NOT (...))
    // instead of the default OR condition with respect to the previous 
    // view criteria row's WHERE clause predicate.
    // vcr2.setConjunction(ViewCriteriaRow.VCROW_CONJ_AND | ViewCriteriaRow.VCROW_CONJ_NOT);
    
    // Syntax to search case-insensitively
    // vcr2.setUpperColumns(true);
    // NOTE: Would need to set the LastName attribute to "BAER"
    // ----  in upper case to have the UPPER(LAST_NAME) predicate match
    
    vc.add(vcr1);
    vc.add(vcr2);
    vo.applyViewCriteria(vc);
    vo.executeQuery();
    while (vo.hasNext()) {
      Row curUser = vo.next();
      System.out.println(curUser.getAttribute("UserId") + " " + 
                         curUser.getAttribute("Email"));
    }
    Configuration.releaseRootApplicationModule(am, true);
  }
}
